######################################################################
# Copyright (c) Boris Baldassari, Adrien Luxey-Bitri
#
# This program and the accompanying materials are made
# available under the terms of the Eclipse Public License 2.0
# which is available at https://www.eclipse.org/legal/epl-2.0/
#
# SPDX-License-Identifier: EPL-2.0
######################################################################

import pytest
from pprint import pprint

import sockets as target

"""
Script to test the sockets.py module.

Use with `pytest test_sockets.py -v`.
"""

port_value = 9999
testdata_port_option = [
    ([], None),
    (['-p', str(port_value)], port_value),
    (['--port', str(port_value)], port_value)
]

@pytest.mark.parametrize("argv, port_value", testdata_port_option)
def test_parse_args_port(argv, port_value):
    args = target.parse_args(argv)
    assert hasattr(args, 'port')
    if port_value is None:
        assert args.port is None 
    else:
        assert args.port == str(port_value) 
