#!/usr/bin/env bash


echo "Working on $1".

build_str() {
    dirout=~/tmp/ue_pe_web/sockets
    rm -rf $dirout

    mkdir -p ${dirout}
    mkdir -p ${dirout}/src/sockets
    mkdir -p ${dirout}/tests

    #cp .gitignore README.md pyproject.toml pdm.lock ${dirout}/
    cp src/sockets/__init__.py src/sockets/sockets.py ${dirout}/src/sockets/
    cp tests/test_sockets.py ${dirout}/tests/
    cd $dirout/..
    zip sockets_student.zip -r sockets/ -x "*.DS_Store"
    cd -
}

if [ "$1" == "student" ]; then
    echo "Setting up student configuration."
    cp src/sockets/sockets{_student,}.py
    cp tests/test_sockets{_student,}.py
elif [ "$1" == "step_1" ]; then
    echo "Setting up configuration for step 1."
    cp src/sockets/sockets{_student_step_1,}.py
    cp tests/test_sockets{_student,}.py    
elif [ "$1" == "step_2" ]; then
    echo "Setting up configuration for step 2."
    cp src/sockets/sockets{_student_step_1,}.py
    cp tests/test_sockets{_complete,}.py    
elif [ "$1" == "complete" ]; then
    echo "Setting up complete configuration."
    cp src/sockets/sockets{_complete,}.py
    cp tests/test_sockets{_complete,}.py    
elif [ "$1" == "reset" ]; then
    echo "Reset exports."
    rm src/sockets/sockets.py
    rm tests/test_sockets.py    
else
    echo "No keyword provided, please use reset, student or complete."
    echo "Not doing anything."
fi

build_str

# Test script.
#pytest .

# Generate documentation from comments.
#pdoc ./sockets.py ./test_sockets.py -o out/ 
